class Date
  GEOLOGIC_TIME_PERIODS = [
    {name:"Archean",lvl: 1,lag: 2500,eag: 4000},
    {name:"Proterozoic",lvl: 1,lag: 541,eag: 2500},
    {name:"Phanerozoic",lvl: 1,lag: 0,eag: 541},
    {name:"Eoarchean",lvl: 2,lag: 3600,eag: 4000},
    {name:"Paleoarchean",lvl: 2,lag: 3200,eag: 3600},
    {name:"Mesoarchean",lvl: 2,lag: 2800,eag: 3200},
    {name:"Neoarchean",lvl: 2,lag: 2500,eag: 2800},
    {name:"Paleoproterozoic",lvl: 2,lag: 1600,eag: 2500},
    {name:"Mesoproterozoic",lvl: 2,lag: 1000,eag: 1600},
    {name:"Neoproterozoic",lvl: 2,lag: 541,eag: 1000},
    {name:"Paleozoic",lvl: 2,lag: 252.2,eag: 541},
    {name:"Mesozoic",lvl: 2,lag: 66,eag: 252.2},
    {name:"Cenozoic",lvl: 2,lag: 0,eag: 66},
    {name:"Siderian",lvl: 3,lag: 2300,eag: 2500},
    {name:"Rhyacian",lvl: 3,lag: 2050,eag: 2300},
    {name:"Orosirian",lvl: 3,lag: 1800,eag: 2050},
    {name:"Statherian",lvl: 3,lag: 1600,eag: 1800},
    {name:"Calymmian",lvl: 3,lag: 1400,eag: 1600},
    {name:"Ectasian",lvl: 3,lag: 1200,eag: 1400},
    {name:"Stenian",lvl: 3,lag: 1000,eag: 1200},
    {name:"Tonian",lvl: 3,lag: 850,eag: 1000},
    {name:"Cryogenian",lvl: 3,lag: 635,eag: 850},
    {name:"Ediacaran",lvl: 3,lag: 541,eag: 635},
    {name:"Cambrian",lvl: 3,lag: 485.4,eag: 541},
    {name:"Ordovician",lvl: 3,lag: 443.4,eag: 485.4},
    {name:"Silurian",lvl: 3,lag: 419.2,eag: 443.4},
    {name:"Devonian",lvl: 3,lag: 358.9,eag: 419.2},
    {name:"Carboniferous",lvl: 3,lag: 298.9,eag: 358.9},
    {name:"Permian",lvl: 3,lag: 252.2,eag: 298.9},
    {name:"Triassic",lvl: 3,lag: 201.3,eag: 252.2},
    {name:"Jurassic",lvl: 3,lag: 145,eag: 201.3},
    {name:"Cretaceous",lvl: 3,lag: 66,eag: 145},
    {name:"Paleogene",lvl: 3,lag: 23.03,eag: 66},
    {name:"Neogene",lvl: 3,lag: 2.588,eag: 23.03},
    {name:"Quaternary",lvl: 3,lag: 0,eag: 2.588},
    {name:"Terreneuvian",lvl: 4,lag: 521,eag: 541},
    {name:"Series 2",lvl: 4,lag: 509,eag: 521},
    {name:"Series 3",lvl: 4,lag: 497,eag: 509},
    {name:"Furongian",lvl: 4,lag: 485.4,eag: 497},
    {name:"Early Ordovician",lvl: 4,lag: 470,eag: 485.4},
    {name:"Middle Ordovician",lvl: 4,lag: 458.4,eag: 470},
    {name:"Late Ordovician",lvl: 4,lag: 443.4,eag: 458.4},
    {name:"Llandovery",lvl: 4,lag: 433.4,eag: 443.4},
    {name:"Wenlock",lvl: 4,lag: 427.4,eag: 433.4},
    {name:"Ludlow",lvl: 4,lag: 423,eag: 427.4},
    {name:"Pridoli",lvl: 4,lag: 419.2,eag: 423},
    {name:"Early Devonian",lvl: 4,lag: 393.3,eag: 419.2},
    {name:"Middle Devonian",lvl: 4,lag: 382.7,eag: 393.3},
    {name:"Late Devonian",lvl: 4,lag: 358.9,eag: 382.7},
    {name:"Mississippian",lvl: 4,lag: 323.2,eag: 358.9},
    {name:"Pennsylvanian",lvl: 4,lag: 298.9,eag: 323.2},
    {name:"Cisuralian",lvl: 4,lag: 272.3,eag: 298.9},
    {name:"Guadalupian",lvl: 4,lag: 259.9,eag: 272.3},
    {name:"Lopingian",lvl: 4,lag: 252.2,eag: 259.9},
    {name:"Early Triassic",lvl: 4,lag: 247.2,eag: 252.2},
    {name:"Middle Triassic",lvl: 4,lag: 237,eag: 247.2},
    {name:"Late Triassic",lvl: 4,lag: 201.3,eag: 237},
    {name:"Early Jurassic",lvl: 4,lag: 174.1,eag: 201.3},
    {name:"Middle Jurassic",lvl: 4,lag: 163.5,eag: 174.1},
    {name:"Late Jurassic",lvl: 4,lag: 145,eag: 163.5},
    {name:"Early Cretaceous",lvl: 4,lag: 100.5,eag: 145},
    {name:"Late Cretaceous",lvl: 4,lag: 66,eag: 100.5},
    {name:"Paleocene",lvl: 4,lag: 56,eag: 66},
    {name:"Eocene",lvl: 4,lag: 33.9,eag: 56},
    {name:"Oligocene",lvl: 4,lag: 23.03,eag: 33.9},
    {name:"Miocene",lvl: 4,lag: 5.333,eag: 23.03},
    {name:"Pliocene",lvl: 4,lag: 2.588,eag: 5.333},
    {name:"Pleistocene",lvl: 4,lag: 0.0117,eag: 2.588},
    {name:"Holocene",lvl: 4,lag: 0,eag: 0.0117},
    {name:"Fortunian",lvl: 5,lag: 529,eag: 541},
    {name:"Stage 2",lvl: 5,lag: 521,eag: 529},
    {name:"Stage 3",lvl: 5,lag: 514,eag: 521},
    {name:"Stage 4",lvl: 5,lag: 509,eag: 514},
    {name:"Stage 5",lvl: 5,lag: 504.5,eag: 509},
    {name:"Drumian",lvl: 5,lag: 500.5,eag: 504.5},
    {name:"Guzhangian",lvl: 5,lag: 497,eag: 500.5},
    {name:"Paibian",lvl: 5,lag: 494,eag: 497},
    {name:"Jiangshanian",lvl: 5,lag: 489.5,eag: 494},
    {name:"Stage 10",lvl: 5,lag: 485.4,eag: 489.5},
    {name:"Tremadocian",lvl: 5,lag: 477.7,eag: 485.4},
    {name:"Floian",lvl: 5,lag: 470,eag: 477.7},
    {name:"Dapingian",lvl: 5,lag: 467.3,eag: 470},
    {name:"Darriwilian",lvl: 5,lag: 458.4,eag: 467.3},
    {name:"Sandbian",lvl: 5,lag: 453,eag: 458.4},
    {name:"Katian",lvl: 5,lag: 445.2,eag: 453},
    {name:"Hirnantian",lvl: 5,lag: 443.4,eag: 445.2},
    {name:"Rhuddanian",lvl: 5,lag: 440.8,eag: 443.4},
    {name:"Aeronian",lvl: 5,lag: 438.5,eag: 440.8},
    {name:"Telychian",lvl: 5,lag: 433.4,eag: 438.5},
    {name:"Sheinwoodian",lvl: 5,lag: 430.5,eag: 433.4},
    {name:"Homerian",lvl: 5,lag: 427.4,eag: 430.5},
    {name:"Gorstian",lvl: 5,lag: 425.6,eag: 427.4},
    {name:"Ludfordian",lvl: 5,lag: 423,eag: 425.6},
    {name:"Pridoli",lvl: 5,lag: 419.2,eag: 423},
    {name:"Lochkovian",lvl: 5,lag: 410.8,eag: 419.2},
    {name:"Pragian",lvl: 5,lag: 407.6,eag: 410.8},
    {name:"Emsian",lvl: 5,lag: 393.3,eag: 407.6},
    {name:"Eifelian",lvl: 5,lag: 387.7,eag: 393.3},
    {name:"Givetian",lvl: 5,lag: 382.7,eag: 387.7},
    {name:"Frasnian",lvl: 5,lag: 372.2,eag: 382.7},
    {name:"Famennian",lvl: 5,lag: 358.9,eag: 372.2},
    {name:"Tournaisian",lvl: 5,lag: 346.7,eag: 358.9},
    {name:"Visean",lvl: 5,lag: 330.9,eag: 346.7},
    {name:"Serpukhovian",lvl: 5,lag: 323.2,eag: 330.9},
    {name:"Bashkirian",lvl: 5,lag: 315.2,eag: 323.2},
    {name:"Moscovian",lvl: 5,lag: 307,eag: 315.2},
    {name:"Kasimovian",lvl: 5,lag: 303.7,eag: 307},
    {name:"Gzhelian",lvl: 5,lag: 298.9,eag: 303.7},
    {name:"Asselian",lvl: 5,lag: 295.5,eag: 298.9},
    {name:"Sakmarian",lvl: 5,lag: 290.1,eag: 295.5},
    {name:"Artinskian",lvl: 5,lag: 279.3,eag: 290.1},
    {name:"Kungurian",lvl: 5,lag: 272.3,eag: 279.3},
    {name:"Roadian",lvl: 5,lag: 268.8,eag: 272.3},
    {name:"Wordian",lvl: 5,lag: 265.1,eag: 268.8},
    {name:"Capitanian",lvl: 5,lag: 259.9,eag: 265.1},
    {name:"Wuchiapingian",lvl: 5,lag: 254.2,eag: 259.9},
    {name:"Changhsingian",lvl: 5,lag: 252.2,eag: 254.2},
    {name:"Induan",lvl: 5,lag: 251.2,eag: 252.2},
    {name:"Olenekian",lvl: 5,lag: 247.2,eag: 251.2},
    {name:"Anisian",lvl: 5,lag: 242,eag: 247.2},
    {name:"Ladinian",lvl: 5,lag: 237,eag: 242},
    {name:"Carnian",lvl: 5,lag: 228,eag: 237},
    {name:"Norian",lvl: 5,lag: 208.5,eag: 228},
    {name:"Rhaetian",lvl: 5,lag: 201.3,eag: 208.5},
    {name:"Hettangian",lvl: 5,lag: 199.3,eag: 201.3},
    {name:"Sinemurian",lvl: 5,lag: 190.8,eag: 199.3},
    {name:"Pliensbachian",lvl: 5,lag: 182.7,eag: 190.8},
    {name:"Toarcian",lvl: 5,lag: 174.1,eag: 182.7},
    {name:"Aalenian",lvl: 5,lag: 170.3,eag: 174.1},
    {name:"Bajocian",lvl: 5,lag: 168.3,eag: 170.3},
    {name:"Bathonian",lvl: 5,lag: 166.1,eag: 168.3},
    {name:"Callovian",lvl: 5,lag: 163.5,eag: 166.1},
    {name:"Oxfordian",lvl: 5,lag: 157.3,eag: 163.5},
    {name:"Kimmeridgian",lvl: 5,lag: 152.1,eag: 157.3},
    {name:"Tithonian",lvl: 5,lag: 145,eag: 152.1},
    {name:"Berriasian",lvl: 5,lag: 139.8,eag: 145},
    {name:"Valanginian",lvl: 5,lag: 132.9,eag: 139.8},
    {name:"Hauterivian",lvl: 5,lag: 129.4,eag: 132.9},
    {name:"Barremian",lvl: 5,lag: 125,eag: 129.4},
    {name:"Aptian",lvl: 5,lag: 113,eag: 125},
    {name:"Albian",lvl: 5,lag: 100.5,eag: 113},
    {name:"Cenomanian",lvl: 5,lag: 93.9,eag: 100.5},
    {name:"Turonian",lvl: 5,lag: 89.8,eag: 93.9},
    {name:"Coniacian",lvl: 5,lag: 86.3,eag: 89.8},
    {name:"Santonian",lvl: 5,lag: 83.6,eag: 86.3},
    {name:"Campanian",lvl: 5,lag: 72.1,eag: 83.6},
    {name:"Maastrichtian",lvl: 5,lag: 66,eag: 72.1},
    {name:"Danian",lvl: 5,lag: 61.6,eag: 66},
    {name:"Selandian",lvl: 5,lag: 59.2,eag: 61.6},
    {name:"Thanetian",lvl: 5,lag: 56,eag: 59.2},
    {name:"Ypresian",lvl: 5,lag: 47.8,eag: 56},
    {name:"Lutetian",lvl: 5,lag: 41.3,eag: 47.8},
    {name:"Bartonian",lvl: 5,lag: 38,eag: 41.3},
    {name:"Priabonian",lvl: 5,lag: 33.9,eag: 38},
    {name:"Rupelian",lvl: 5,lag: 28.1,eag: 33.9},
    {name:"Chattian",lvl: 5,lag: 23.03,eag: 28.1},
    {name:"Aquitanian",lvl: 5,lag: 20.44,eag: 23.03},
    {name:"Burdigalian",lvl: 5,lag: 15.97,eag: 20.44},
    {name:"Langhian",lvl: 5,lag: 13.82,eag: 15.97},
    {name:"Serravallian",lvl: 5,lag: 11.62,eag: 13.82},
    {name:"Tortonian",lvl: 5,lag: 7.246,eag: 11.62},
    {name:"Messinian",lvl: 5,lag: 5.333,eag: 7.246},
    {name:"Zanclean",lvl: 5,lag: 3.6,eag: 5.333},
    {name:"Piacenzian",lvl: 5,lag: 2.588,eag: 3.6},
    {name:"Gelasian",lvl: 5,lag: 1.806,eag: 2.588},
    {name:"Calabrian",lvl: 5,lag: 0.781,eag: 1.806},
    {name:"Middle Pleistocene",lvl: 5,lag: 0.126,eag: 0.781},
    {name:"Late Pleistocene",lvl: 5,lag: 0.0117,eag: 0.126},
    {name:"Holocene",lvl: 5,lag: 0,eag: 0.0117}
  ]

  def self.geologic_present
    Date.new(1950,1,1)
  end

  def self.million_years_ago(years)
    Date.geologic_present - (years*365*1000000).to_i
  end

  def in_geologic_time_range?(million_years_start, million_years_end)
    time_period_start = Date.million_years_ago(million_years_start)
    time_period_end = million_years_end == 0 ? Date.today : Date.million_years_ago(million_years_end)
    (time_period_start..time_period_end).cover?(self)
  end

  def after_dinosaurs?
    self > Date.million_years_ago(65)
  end

  GEOLOGIC_TIME_PERIODS.each do |time_period|
    define_method("in_#{time_period[:name].downcase.tr(' ', '_')}?") { in_geologic_time_range?(time_period[:eag], time_period[:lag]) }
  end
end
